modimport("scripts/prefabs.lua")
modimport("scripts/activateforce.lua")
modimport("scripts/steambitems.lua")
modimport("scripts/forgelevellogic.lua")
modimport("scripts/lootdropperzero.lua")

local STRINGS = GLOBAL.STRINGS
local require = GLOBAL.require
require "steamstrings"

GLOBAL.TUNING.METEOR_DAMAGE = 150
GLOBAL.TUNING.METEOR_RADIUS = 2.5
GLOBAL.TUNING.METEOR_FRIENDLY_RADIUS = 4

STRINGS.UI.LOADGAMESCREEN.MODDED = "Forgotten Forge"

--Changes "pick up" to "use" for "food machine".
AddSimPostInit(function(inst)
	local oldactionstringoverride = inst.ActionStringOverride
	function inst:ActionStringOverride(bufaction)
		if bufaction.action == GLOBAL.ACTIONS.PICK and bufaction.target and bufaction.target.prefab == "foodgen" then
			return "Use"
		elseif bufaction.action == GLOBAL.ACTIONS.ACTIVATEBOSS and bufaction.target and bufaction.target.prefab == "copper_anvil" then
			return "Forge"
		end
		if oldactionstringoverride then
			return oldactionstringoverride(inst, bufaction)
		end
	end
end)

local Levels = GLOBAL.require("map/levels")


Assets=
{


----Load Screen---------------------------------------------------
    Asset( "ANIM", "anim/lava_generating_world.zip" ), 
----Lava Waves image---------------------------------------------------
    Asset( "IMAGE", "images/lavawave.tex" ),

}

local function UpdateWorldGenScreen(self, profile, cb, world_gen_options)
	local data=Levels.custom_levels[world_gen_options.level_world]
      if(world_gen_options.level_type and world_gen_options.level_type=="adventure")then return end
	  if(world_gen_options.level_type and world_gen_options.level_type=="cave")then return end
	  if(world_gen_options.level_type and world_gen_options.level_type=="survival")then return end
	  if(world_gen_options.level_type and world_gen_options.level_type=="shipwrecked")then return end
	  if(world_gen_options.level_type and world_gen_options.level_type=="volcano")then return end
	  if(world_gen_options.level_type and world_gen_options.level_type=="porkland")then return end
	  
	  
      if(data and data.id == "FORGOTTENFORGE")then
				GLOBAL.TheSim:LoadPrefabs {"MOD_"..modname}
				
				self.bg:SetTint(229/255, 175/255, 38/255, 1)
                self.worldanim:GetAnimState():SetBank("lava_generating_world")
                self.worldanim:GetAnimState():SetBuild("lava_generating_world")
                self.worldanim:GetAnimState():PlayAnimation("idle", true)
				
				self.worldgentext:SetString(STRINGS.UI.WORLDGEN.FORGE_TITLE)
			
				self.verbs = GLOBAL.shuffleArray(STRINGS.UI.WORLDGEN.FORGE_VERBS) 
				self.nouns = GLOBAL.shuffleArray(STRINGS.UI.WORLDGEN.FORGE_NOUNS)
			
    
     end
end

AddClassPostConstruct("screens/worldgenscreen", UpdateWorldGenScreen)


AddPrefabPostInit("forest", function(inst)



		if GLOBAL.SaveGameIndex:GetCurrentMode() == "forgottenforge" then  
		local waves = inst.entity:AddWaveComponent()
				waves:SetWaveTexture(GLOBAL.resolvefilepath( "images/lavawave.tex" ))
		inst.components.ambientsoundmixer:SetReverbPreset("cave")

	
		end
	end)

