modimport("scripts/tile_adder.lua")

GLOBAL.require("constants")
local GROUND = GLOBAL.GROUND
GLOBAL.require("map/lockandkey")
GLOBAL.require("map/tasks")
local LOCKS = GLOBAL.LOCKS
local KEYS = GLOBAL.KEYS
local Layouts = GLOBAL.require("map/layouts").Layouts
local StaticLayout = GLOBAL.require("map/static_layout")
local SIZE_VARIATION = 3


GLOBAL.require("map/terrain")

GLOBAL.terrain.rooms.BGRocky.contents.distributeprefabs.stonehand = 0.5
GLOBAL.terrain.rooms.BGChessRocky.contents.distributeprefabs.stonehand = 0.5
GLOBAL.terrain.rooms.Rocky.contents.distributeprefabs.stonehand = 0.5
GLOBAL.terrain.rooms.RockLobsterPlains.contents.distributeprefabs.stonehand = .05
GLOBAL.terrain.rooms.BatCaveRoomAntichamber.contents.distributeprefabs.stonehand = .05
GLOBAL.terrain.filter.stonehand = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.MARSH}

if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) then 
GLOBAL.terrain.rooms.Magma.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.MagmaHome.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.VolcanoRock.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.MolesvilleRockyIsland.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.RockyGold.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.BeachSand.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.rooms.JungleClearing.contents.distributeprefabs.stonehand = 0.1
GLOBAL.terrain.filter.stonehand = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
GLOBAL.terrain.filter.tesla_jungle = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
GLOBAL.terrain.filter.jungletree = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
GLOBAL.terrain.filter.schest_loot = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
GLOBAL.terrain.filter.ancient6 = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
GLOBAL.terrain.filter.foodgen_jungle = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.ROCKY, GROUND.MANGROVE_SHORE, GROUND.OCEAN_SHORE, GROUND.OCEAN_SHALLOW, GROUND.OCEAN_CORAL,  GROUND.OCEAN_CORAL_SHORE,}
end

if GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then 
GLOBAL.terrain.rooms.BG_plains_base.contents.distributeprefabs.stonehand = 0.04
GLOBAL.terrain.rooms.BG_painted_base.contents.distributeprefabs.stonehand = 0.05
GLOBAL.terrain.rooms.BG_rainforest_base.contents.distributeprefabs.stonehand = 0.05
GLOBAL.terrain.filter.stonehand = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER, GLOBAL.GROUND.MARSH}
end

if GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC) then
AddTile("TECH", 84, "tech", {noise_texture = "levels/textures/noise_tech.tex",    runsound="run_marble",		walksound="walk_marble",	snowsound="run_ice", mudsound = "run_mud"}, {noise_texture = "levels/textures/mini_noise_tech.tex"})
AddTile("WHITEFLOOR", 86, "whitefloor", {noise_texture = "levels/textures/noise_whitefloor.tex",     runsound="run_marble",		walksound="walk_marble",	snowsound="run_ice", mudsound = "run_mud"}, {noise_texture = "levels/textures/mini_noise_whitefloor.tex"})
AddTile("LAVA", 88, "lava", {noise_texture = "levels/textures/lava_noise.tex",    runsound="run_marble",		walksound="walk_marble",	snowsound="run_ice", mudsound = "run_mud"}, {noise_texture = "levels/textures/mini_lava_noise.tex"})
else
AddTile("TECH", 84, "tech", {noise_texture = "levels/textures/noise_tech.tex",    runsound="dontstarve/movement/run_marble",		walksound="dontstarve/movement/walk_marble",	snowsound="dontstarve/movement/run_ice", mudsound = "dontstarve/movement/run_mud"}, {noise_texture = "levels/textures/mini_noise_tech.tex"})
AddTile("WHITEFLOOR", 86, "whitefloor", {noise_texture = "levels/textures/noise_whitefloor.tex",     runsound="dontstarve/movement/run_marble",		walksound="dontstarve/movement/walk_marble",	snowsound="dontstarve/movement/run_ice", mudsound = "dontstarve/movement/run_mud"}, {noise_texture = "levels/textures/mini_noise_whitefloor.tex"})
AddTile("LAVA", 88, "lava", {noise_texture = "levels/textures/lava_noise.tex",    runsound="dontstarve/movement/run_marble",		walksound="dontstarve/movement/walk_marble",	snowsound="dontstarve/movement/run_ice", mudsound = "dontstarve/movement/run_mud"}, {noise_texture = "levels/textures/mini_lava_noise.tex"})
end

Layouts["SpawnLava"] = StaticLayout.Get("map/static_layouts/spawnlava")
Layouts["Rhinotown"] = StaticLayout.Get("map/static_layouts/rhinotown")
Layouts["Bosslair"] = StaticLayout.Get("map/static_layouts/bosslair")

modimport("scripts/map/rooms/steam_rooms.lua")
modimport("scripts/map/tasks/steam_tasks.lua")
modimport("scripts/map/levels/steam_levels.lua")









