local ACTIONS = GLOBAL.ACTIONS
local STRINGS = GLOBAL.STRINGS
ActionHandler = GLOBAL.ActionHandler
Vector3 = GLOBAL.Vector3

local SpawnPrefab = GLOBAL.SpawnPrefab
local FindWalkableOffset = GLOBAL.FindWalkableOffset
local PI = GLOBAL.PI

--[[local function Charge(FiniteUses)
	function FiniteUses:Recharge(num)
		self:SetUses(self.current + (num or 1))
	end
end

AddComponentPostInit("finiteuses", Charge)]]




GLOBAL.STRINGS.ACTIONS.ACTIVATEFORCE = "Activate"
GLOBAL.STRINGS.ACTIONS.CHARGER = "Charge"
GLOBAL.STRINGS.ACTIONS.ACTIVATEBOSS = "Insert Battery"

function ForcefieldSimPostInit()

ACTIONS.ACTIVATEFORCE = GLOBAL.Action({})
ACTIONS.ACTIVATEFORCE.fn = function(act)
 local tar = act.target or act.invobject
  if tar and tar.components.activateforce then
        tar.components.activateforce:Working(tar)
        return true
    end
end

ACTIONS.CHARGER = GLOBAL.Action({}, 2, true, true)
ACTIONS.CHARGER.fn = function(act)
	if act.target and act.invobject and act.invobject.components.charger then
		return act.invobject.components.charger:Docharge(act.target, act.doer)
	end
end

ACTIONS.ACTIVATEBOSS = GLOBAL.Action({})
ACTIONS.ACTIVATEBOSS.fn = function(act)
if act.target.components.activator then
		act.target.components.activator:AcceptGift(act.doer, act.invobject)
	    return true
    end
end

ACTIONS.METEORBOSS = GLOBAL.Action({},0, false, false, 30)
ACTIONS.METEORBOSS.fn = function(act)
	if act.doer.components.combat and
	act.target and not
	act.doer.components.health:IsDead() then
		local nummeteor = 1
		if act.doer.prefab == "metal_boss" then
			act.doer:GetTimeAlive()
			nummeteor = math.min(GLOBAL.Lerp(2, 15, act.doer:GetTimeAlive()/250), 15)
		end
		for i = 1, nummeteor do
			act.doer:DoTaskInTime((1 * math.random()) + .33, function() 
		        local pt = act.target:GetPosition()
		        local theta = math.random() * 2 * PI
				local radius = math.random(0, nummeteor)
		        local offset = FindWalkableOffset(pt, theta, radius, 12, true)
		        if offset then
		        	pt = pt + offset
		        end
		        local meteor = SpawnPrefab("meteor_boss")
		        meteor.Transform:SetPosition(pt:Get())
	        end)
	    end
		return true	    
	end
end





for k,v in pairs(ACTIONS) do
	 if k == "ACTIVATEFORCE" or "CHARGER" or "METEORBOSS" or "ACTIVATEBOSS" then
    		v.str = STRINGS.ACTIONS[k] or "ACTION"
   		 v.id = k
	 end
end 

-- required to extract animation

local function addActionHandler(SGname, action, state, condition)
	actionHandler = GLOBAL.ActionHandler(action, state, condition)
	for k,v in pairs(GLOBAL.SGManager.instances) do	
		if(k.sg.name == SGname) then
			k.sg.actionhandlers[action] = actionHandler
			break
		end
	end 
end

local function addState(SGname, state)
	 for k,v in pairs(GLOBAL.SGManager.instances) do	
		if(k.sg.name == SGname) then
			k.sg.states[state.name] =  state
			break
		end
	 end
end

-- Activate anim and sound

addActionHandler("wilson", GLOBAL.ACTIONS.ACTIVATEFORCE, "activateforce")

local activateforce = GLOBAL.State{
        name = "activateforce",
        tags = {"doing"},
        
        onenter = function(inst, timeout)
            
            inst.sg:SetTimeout(timeout or 1)
            inst.components.locomotor:Stop()
            inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod", "make")
            
            inst.AnimState:PlayAnimation("build_pre")
            inst.AnimState:PushAnimation("build_loop", true)
        end,
        
        ontimeout= function(inst)
            inst.AnimState:PlayAnimation("build_pst")
            inst.sg:GoToState("idle", false)
            inst:PerformBufferedAction()
        
        end,
        
        onexit= function(inst)
            inst.SoundEmitter:KillSound("make")
        end, 
    }

    addState("wilson", activateforce)
	
	addActionHandler("wilson", GLOBAL.ACTIONS.ACTIVATEBOSS, "activateboss")

local activateboss = GLOBAL.State{
        name = "activateboss",

        
		onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("give") 
        end,
        
        timeline =
        {
            GLOBAL.TimeEvent(13*GLOBAL.FRAMES, function(inst)
                inst:PerformBufferedAction()
            end),
        },        

        events=
        {
            GLOBAL.EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
        },
    }

    addState("wilson", activateboss)
	
	end
AddSimPostInit(ForcefieldSimPostInit)