require "behaviours/wander"
require "behaviours/faceentity"
require "behaviours/chaseandattack"
require "behaviours/panic"
require "behaviours/follow"
require "behaviours/attackwall"

local MetalBossBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

local function summonmeteor(inst) --Always, decreased CD as lower hp
    local tar = inst.components.combat.target
    if tar and not inst.METEORCD and not inst.components.health:IsDead() and not
    inst.sg:HasStateTag("busy") and
    math.random() > .45 then
        inst.METEORCD = true        
        local current = inst.components.health.currenthealth
        local max = inst.components.health.maxhealth
        local cooldown = Lerp(10, 15, current/max)
        cooldown = GetRandomWithVariance(cooldown, 5)
        inst:DoTaskInTime(cooldown, function() inst.METEORCD = false end)
        
        return BufferedAction(inst, tar, ACTIONS.METEORBOSS)
    end
end

function MetalBossBrain:OnStart()
    local root = PriorityNode(
    {
        DoAction(self.inst, summonmeteor),
        ChaseAndAttack(self.inst, 1000),
        Wander(self.inst, function() return self.inst:GetPosition() end, 10)
    }, .25)
    
    self.bt = BT(self.inst, root)    
end

return MetalBossBrain