local assets=
{
	Asset("ANIM", "anim/ancient1.zip"),
	Asset("ATLAS", "images/inventoryimages/ancient1_map.xml"),
    Asset("IMAGE", "images/inventoryimages/ancient1_map.tex"),
	Asset("SOUND", "sound/common.fsb"),

}

local prefabs = 

{
	"trinket_6",
	"metal",
	"gears",
	"thulecite", 
	"greengem",
	"yellowgem",
	"orangegem",
	"mechalance",
}

SetSharedLootTable( 'ancientloot1',
{
    {'trinket_6',  0.5},
	{'metal',  0.4},
	{'gears',  0.2},
	{'thulecite',  0.1},
	{'greengem',  0.03},
	{'yellowgem',  0.03},
	{'orangegem',  0.03},
 
})

local function onnear(inst)
	--hive pop open? Maybe rustle to indicate danger?
	--more and more come out the closer you get to the nest?
	inst.AnimState:PlayAnimation("load")
	inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_fuse_LP")
	
	inst:DoTaskInTime(1, function()
		
	if inst.components.childspawner then
		inst.components.childspawner:ReleaseAllChildren(GetPlayer(), "mechalance")
		inst.AnimState:PlayAnimation("idle")
	end
	end)
end

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("idle")
	if inst.components.childspawner then
		inst.components.childspawner:ReleaseAllChildren(GetPlayer(), "mechalance")
	end
end


local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "ancient1_map.tex" )
    
    inst:AddTag("structure")
	MakeObstaclePhysics(inst, .5)
    
    inst.AnimState:SetBank("ancient1")
    inst.AnimState:SetBuild("ancient1")
	inst.AnimState:PlayAnimation("idle")
		
    inst:AddComponent("inspectable")
	
	inst:AddComponent("childspawner")
	inst.components.childspawner.childspawner = "mechalance"
	inst.components.childspawner:SetMaxChildren(3)
	
	inst:AddComponent("playerprox")
	inst.components.playerprox:SetDist(10,13) --set specific values
	inst.components.playerprox:SetOnPlayerNear(onnear)
	inst.components.playerprox:Schedule()
	--inst.components.playerprox:SetOnPlayerFar(onfar)
	
	
	inst:AddComponent("lootdropper")
	inst.components.lootdropper:SetChanceLootTable('ancientloot1')
	
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(3)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit) 
	
	
    return inst
end


STRINGS.NAMES.ANCIENT1 = "Strange Device"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ANCIENT1 = {	
	"Specialized invention ... I think.",
	 
}

STRINGS.CHARACTERS.WX78.DESCRIBE.ANCIENT1 = {	
	"NO DATA.",
	 
}

STRINGS.CHARACTERS.WAXWELL.DESCRIBE.ANCIENT1 = {	
	"The latest defense system.",
	 
}

return Prefab( "common/ancient1", fn, assets, prefabs)