require "prefabutil"

local assets=
{
	Asset("ANIM", "anim/copper_anvil.zip"),
    Asset("ATLAS", "images/inventoryimages/copper_anvil.xml"),
    Asset("IMAGE", "images/inventoryimages/copper_anvil.tex"),

}

local prefabs = 

{
 --"campfirefire",
 --"smokeex",
}

local function onhammered(inst, worker)

	inst.components.lootdropper:SetLoot({"redgem","stone","twigs"})
	inst.components.lootdropper:AddChanceLoot("cutgrass" , 0.5)
	inst.components.lootdropper:AddChanceLoot("twigs" , 0.4)
    inst.components.lootdropper:AddChanceLoot("twigs" , 0.3)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("idle")
end


local function onbuilt(inst)
	inst.AnimState:PlayAnimation("idle")
	inst.AnimState:PushAnimation("idle", false)
end


local function OnGetItemFromPlayer(inst, giver, item)
	
	local nug = nil

    if item.components.activatorfuel.greengemvalue == 1 and not inst:HasTag("broken_f") then
		
		inst.AnimState:PlayAnimation("working", true)
		
		inst:DoTaskInTime(0.5, function()
		inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
		end)
		
		inst:DoTaskInTime(1, function()
		
		inst.AnimState:PushAnimation("idle", true)
		
		nug = SpawnPrefab("metal")
		
		local pt = Vector3(inst.Transform:GetWorldPosition()) + Vector3(0,4.5,0)
                
		nug.Transform:SetPosition(pt:Get())
        local down = TheCamera:GetDownVec()
        local angle = math.atan2(down.z, down.x) + (math.random()*60-30)*DEGREES
        local sp = math.random()*4+2
        nug.Physics:SetVel(sp*math.cos(angle), math.random()*2+8, sp*math.sin(angle))
		end)		
    end
end

local function OnRefuseItem(inst, giver, item)

	inst.AnimState:PushAnimation("idle", true)

end



local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "copper_anvil.tex" )
    
    inst:AddTag("structure")
    MakeObstaclePhysics(inst, .5)
    
    inst.AnimState:SetBank("copper_anvil")
    inst.AnimState:SetBuild("copper_anvil")
	inst.AnimState:PlayAnimation("idle")

    inst:AddComponent("inspectable")
	

	inst:AddComponent("activator")

	inst.components.activator:SetAcceptTest(
		function(inst, item)
			return item.components.activatorfuel.greengemvalue > 0
		end)
	
	inst.components.activator.onaccept = OnGetItemFromPlayer
    inst.components.activator.onrefuse = OnRefuseItem
	
	inst:AddComponent("lootdropper")
	inst:AddComponent("norecipelootdropper")	
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit) 
	
	inst:ListenForEvent( "onbuilt", onbuilt)
	

    return inst
end


STRINGS.NAMES.COPPER_ANVIL = "Anvil"
STRINGS.RECIPE_DESC.COPPER_ANVIL = "For copper processing"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COPPER_ANVIL = {	
		"A piece of stone",
		}
STRINGS.CHARACTERS.WX78.DESCRIBE.COPPER_ANVIL = {	
		"USEFUL STONE",
		}


-- Add recipe
if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then 
local crafting_recipe = Recipe("copper_anvil", {Ingredient("hammer", 1),Ingredient("cutstone", 4), Ingredient("redgem", 1)}, RECIPETABS.SCIENCE,  TECH.SCIENCE_ONE, RECIPE_GAME_TYPE.COMMON, "copper_anvil_placer")
crafting_recipe.atlas = "images/inventoryimages/copper_anvil.xml"
else
local crafting_recipe = Recipe("copper_anvil", {Ingredient("hammer", 6),Ingredient("cutstone", 4), Ingredient("redgem", 1)}, RECIPETABS.SCIENCE,  TECH.SCIENCE_ONE, "copper_anvil_placer")
crafting_recipe.atlas = "images/inventoryimages/copper_anvil.xml"
end


return Prefab( "common/copper_anvil", fn, assets, prefabs),
	MakePlacer( "common/copper_anvil_placer", "copper_anvil", "copper_anvil", "idle" ) 
