local assets=
{
	Asset("ANIM", "anim/lapple.zip"),
	
	Asset("ATLAS", "images/inventoryimages/lapple.xml"),
	Asset("IMAGE", "images/inventoryimages/lapple.tex"),
}

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBuild("lapple")
    inst.AnimState:SetBank("lapple")
    inst.AnimState:PlayAnimation("Idle")

    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("edible")
	inst.components.edible.foodtype = "GENERIC"
	
    inst.components.edible.hungervalue = 20
	inst.components.edible.sanityvalue = 5
	inst.components.edible.temperaturedelta = 20
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"

	
    inst:AddComponent("inspectable")
	
	inst:AddComponent("tradable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/lapple.xml"	
	
    
    return inst
end

STRINGS.NAMES.LAPPLE = "Fire Apple"

-- Randomizes the inspection line upon inspection.
STRINGS.CHARACTERS.GENERIC.DESCRIBE.LAPPLE = {	
	"Heavily warming.",
	"Hot and sweet.",
}
STRINGS.CHARACTERS.WX78.DESCRIBE.LAPPLE = {	
	"MORE ENERGY",
	 
}

AddIngredientValues({"lapple"}, {fruit=1}, true)

return Prefab( "common/inventory/lapple", fn, assets) 
