local assets=
{
	Asset("ANIM", "anim/metal_boss.zip"),
	Asset("SOUND", "sound/bat.fsb"),

}

local prefabs =
{
    "forcefieldn",
    "gears",
    "metal",
	"trinket_6",
}

SetSharedLootTable( 'metal_boss1',
{
    {'forcefieldn',1.0},
    {'gears',0.3},
    {'metal',0.3},
    {'trinket_6',0.3},
})

local SLEEP_DIST_FROMHOME = 1
local SLEEP_DIST_FROMTHREAT = 20
local MAX_CHASEAWAY_DIST = 50
local MAX_TARGET_SHARES = 5
local SHARE_TARGET_DIST = 40

local function Retarget(inst)
	return GetPlayer()
end

local function KeepTarget(inst, target)
	return target == GetPlayer()
end


function firefn(inst)
	inst.sg:GoToState("summon_forcefield")
    local num_lightnings =  16
    inst:StartThread(function()
        for k = 0, num_lightnings do

            local rad = math.random(3, 15)
            local angle = k*((4*PI)/num_lightnings)
            local pos = Vector3(inst.Transform:GetWorldPosition()) + Vector3(rad*math.cos(angle), 0, rad*math.sin(angle))
            GetSeasonManager():DoLightningStrike(pos)
            Sleep(math.random( .3, .5))
        end
    end)
	
	
    return true

	end


function tentaclesfn(inst)

	inst.sg:GoToState("summon_forcefield")
    local pt = Vector3(inst.Transform:GetWorldPosition())

    local numtentacles = 6

    inst:StartThread(function()
        for k = 1, numtentacles do
        
            local theta = math.random() * 2 * PI
            local radius = math.random(3, 8)


			
			local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
                local x,y,z = (pt + offset):Get()
                local ents = TheSim:FindEntities(x,y,z , 1)
                return not next(ents) 
            end)

            if result_offset then
                local tentacle = SpawnPrefab("mechatentacle")
                
                tentacle.Transform:SetPosition((pt + result_offset):Get())
                GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.2, 0.02, .25, 40)
                
                --need a better effect
                local fx = SpawnPrefab("splash_ocean")
                local pos = pt + result_offset
                fx.Transform:SetPosition(pos.x, pos.y, pos.z)
                --PlayFX((pt + result_offset), "splash", "splash_ocean", "idle")
                tentacle.sg:GoToState("attack_pre")
            end

            Sleep(.33)
        end
    end)
	
	inst:InterruptBufferedAction()
    inst:ClearBufferedAction()
    inst.sg:GoToState("idle")

    GetPlayer().components.combat.target = nil
    GetPlayer().components.combat.lasttargetGUID = nil
	
	
    return true    
end

function mechabatfn(inst)

	inst.sg:GoToState("summon_forcefield")
    local pt = Vector3(inst.Transform:GetWorldPosition())

    local numtentacles = 6

    inst:StartThread(function()
        for k = 1, numtentacles do
        
            local theta = math.random() * 2 * PI
            local radius = math.random(3, 8)

            -- we have to special case this one because birds can't land on creep
			local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
                local x,y,z = (pt + offset):Get()
                local ents = TheSim:FindEntities(x,y,z , 1)
                return not next(ents) 
            end)

            if result_offset then
                local tentacle = SpawnPrefab("mechabat")
				
				
                SpawnPrefab("statue_transition").Transform:SetPosition((pt + result_offset):Get())
				SpawnPrefab("statue_transition_2").Transform:SetPosition((pt + result_offset):Get())
                tentacle.Transform:SetPosition((pt + result_offset):Get())
                GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.2, 0.02, .25, 40)
                
                --need a better effect
                local fx = SpawnPrefab("splash_ocean")
                local pos = pt + result_offset
                fx.Transform:SetPosition(pos.x, pos.y, pos.z)
                --PlayFX((pt + result_offset), "splash", "splash_ocean", "idle")
            end

        end
    end)
	
	inst:InterruptBufferedAction()
    inst:ClearBufferedAction()
    inst.sg:GoToState("idle")

    GetPlayer().components.combat.target = nil
    GetPlayer().components.combat.lasttargetGUID = nil
	
    return true    
end


local function onhealthdelta(inst, data)
    if (data.oldpercent > .8 and data.newpercent <= .8) then
        firefn(inst)
    elseif (data.oldpercent > .6 and data.newpercent <= .6) then
        tentaclesfn(inst)
	elseif (data.oldpercent > .4 and data.newpercent <= .4) then
        mechabatfn(inst)	
    elseif (data.oldpercent > .2 and data.newpercent <= .2) then
        tentaclesfn(inst)
		inst:DoTaskInTime(2, function()  
			mechabatfn(inst)	
		end)
    end
end


local function OnAttacked(inst, data)
	
if math.random() > .75 then	
		--	local inst = GetPlayer()
		inst:AddTag("forcefield")
		inst.sg:GoToState("summon_forcefield")
		inst.components.health:SetInvincible(true)
       -- inst.components.health.absorb = (1)
        local fx = SpawnPrefab("greenfieldfx")
        fx.entity:SetParent(inst.entity)
        fx.Transform:SetPosition(0, 0.2, 0)
        local fx_hitanim = function()
            fx.AnimState:PlayAnimation("hit")
            fx.AnimState:PushAnimation("idle_loop")
        end
        fx:ListenForEvent("blocked", fx_hitanim, inst)

        inst.active = true

        inst:DoTaskInTime(--[[Duration]] 15, function()
            fx:RemoveEventCallback("blocked", fx_hitanim, inst)
            fx.kill_fx(fx)
            if inst:IsValid() then
                inst:RemoveTag("forcefield")
				inst.components.health:SetInvincible(false)
            --    inst.components.health.absorb = (0)
                inst:DoTaskInTime(--[[Cooldown]] 4, function() inst.active = false end)
            end
        end)
end	

    local attacker = data and data.attacker
    if attacker and attacker:HasTag("chess") then return end
    inst.components.combat:SetTarget(attacker)
    inst.components.combat:ShareTarget(attacker, SHARE_TARGET_DIST, function(dude) return dude:HasTag("chess") end, MAX_TARGET_SHARES)
	
end

local function SparkAttack(inst)

if math.random() > .75 then
	inst.sg:GoToState("summon_spark")
end

end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 1.5, .75 )
    inst.Transform:SetFourFaced()

    local scaleFactor = 1.50
    inst.Transform:SetScale(scaleFactor, scaleFactor, scaleFactor)
    
    MakeGhostPhysics(inst, 1, .5)

    anim:SetBank("metal_boss")
    anim:SetBuild("metal_boss")
    
    inst:AddComponent("locomotor")
    inst.components.locomotor:SetSlowMultiplier( 1 )
    inst.components.locomotor:SetTriggersCreep(false)
    inst.components.locomotor.pathcaps = { ignorecreep = true }
    inst.components.locomotor.walkspeed = 6    

    inst:AddTag("monster")
    inst:AddTag("hostile")
    inst:AddTag("chess")
    inst:AddTag("flying")
 
    local brain = require "brains/metalbossbrain"
    inst:SetBrain(brain)
	
	inst:SetStateGraph("SGmetal_boss")

    inst:AddComponent("combat")
    inst.components.combat.hiteffectsymbol = "bat_body"
    inst.components.combat:SetAttackPeriod(TUNING.BAT_ATTACK_PERIOD)
    inst.components.combat:SetRange(TUNING.BAT_ATTACK_DIST)
    inst.components.combat:SetRetargetFunction(2, Retarget)
    inst.components.combat:SetKeepTargetFunction(KeepTarget)
    inst:AddComponent("health")
    inst.components.health:SetMaxHealth(1500)
    inst.components.combat:SetDefaultDamage(40)
    inst.components.combat:SetAttackPeriod(TUNING.BAT_ATTACK_PERIOD)

    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('metal_boss1')

    inst:AddComponent("inventory")

    
    inst:AddComponent("inspectable")
    inst:AddComponent("knownlocations")
    
    inst:DoTaskInTime(1*FRAMES, function() inst.components.knownlocations:RememberLocation("home", Vector3(inst.Transform:GetWorldPosition()), true) end)
   

    inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent("onattackother", SparkAttack)
	inst:ListenForEvent("healthdelta", onhealthdelta)
    
    return inst
end

STRINGS.NAMES.METAL_BOSS = "Metal Golem"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.METAL_BOSS = {	
	"Insane machine.",
	 
}

STRINGS.CHARACTERS.WX78.DESCRIBE.METAL_BOSS = {	
	"FLYING AUTOMATON.",
	 
}

return Prefab("chessboard/metal_boss", fn, assets, prefabs) 
