local assets=
{
	Asset("ANIM", "anim/metal_boss.zip"),

}

local prefabs =
{
    "gears",
    "metal",
	"trinket_6",
}

SetSharedLootTable( 'metal_boss2',
{
    {'gears',0.3},
    {'metal',0.3},
    {'trinket_6',0.3},

})

local function OnGetItemFromPlayer(inst, giver, item)
		local boss = SpawnPrefab("metal_boss")
	if item.components.activatorfuel.greengemvalue == 2 then	
		
		
		inst.AnimState:PlayAnimation("activate")
		inst.SoundEmitter:PlaySound("dontstarve/common/chesspile_ressurect")
		inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
		GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.5, 0.04, .4, 40)
		inst:DoTaskInTime(2, function()  
		boss.Transform:SetPosition(inst.Transform:GetWorldPosition())
		inst:Remove()
		end)
	end
	
end

local function OnRefuseItem(inst, giver, item)

	inst.AnimState:PushAnimation("off", true)

end



local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
	local shadow = inst.entity:AddDynamicShadow()
	shadow:SetSize( 1.5, .75 )
	
	local scaleFactor = 1.50
    inst.Transform:SetScale(scaleFactor, scaleFactor, scaleFactor)
    
	inst:AddTag("structure")

    
    MakeObstaclePhysics(inst, 1.2)

    anim:SetBank("metal_boss")
    anim:SetBuild("metal_boss")
	inst.AnimState:PlayAnimation("off")


    inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('metal_boss2')

	
	inst:AddComponent("activator")

	inst.components.activator:SetAcceptTest(
		function(inst, item)
			return item.components.activatorfuel.greengemvalue > 1
		end)
	
	inst.components.activator.onaccept = OnGetItemFromPlayer
    inst.components.activator.onrefuse = OnRefuseItem

    inst:AddComponent("inspectable")
	
    return inst
end

STRINGS.NAMES.METAL_BOSS_OFF = "Metal Golem"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.METAL_BOSS_OFF = {	
	"It doesn't work ... maybe it can be turned on?",
	 
}

STRINGS.CHARACTERS.WX78.DESCRIBE.METAL_BOSS_OFF = {	
	"OFFLINE - NEEDED BATTERY",
	 
}

return Prefab("chessboard/metal_boss_off", fn, assets, prefabs) 
