local assets =
{
    Asset("ANIM", "anim/meteor_boss.zip"),
    Asset("ANIM", "anim/meteor_boss_shadow.zip"),
}

local prefabs =
{
    "meteorwarning"
}

local function onexplode(inst)

    inst.SoundEmitter:PlaySound("dontstarve/common/meteor_impact")

    if inst.warnshadow then
        inst.warnshadow:Remove()
    end
	--SpawnPrefab("explode_small").Transform:SetPosition(inst:GetPosition():Get())
	GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.7, 0.02, .5, 40)
	local pos = inst:GetPosition()
	local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, TUNING.METEOR_RADIUS)
    for k,v in pairs(ents) do
        local inpocket = v.components.inventoryitem and v.components.inventoryitem:IsHeld()

        if not inpocket then
            if v.components.workable and not v:HasTag("busy") then
                v.components.workable:WorkedBy(inst, 20)
            end

            if v.components.combat and v == GetPlayer() then
                v.components.combat:GetAttacked(inst, TUNING.METEOR_DAMAGE, nil)
            end
        end
    end

    ents = TheSim:FindEntities(pos.x, pos.y, pos.z, TUNING.METEOR_FRIENDLY_RADIUS)

    for k,v in pairs(ents) do
        local inpocket = v.components.inventoryitem and v.components.inventoryitem:IsHeld()
        if not inpocket then
            if (v.prefab == "shadowmaxwell" or v.prefab == "shadowmaxwell_image")
            and v.components.health and not v.components.health:IsDead() then
                v.sg:GoToState("stunned")
            end
        end
    end
end

local function dostrike(inst)
    inst.AnimState:PlayAnimation("crash")
    inst:DoTaskInTime(0.33, onexplode)
    inst:ListenForEvent("animover", function() inst:Remove() end)
end

local warntime = 1

local function fn() 
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    
    trans:SetTwoFaced()
    trans:SetRotation(math.random(1, 360))

	anim:SetBank("meteor")
	anim:SetBuild("meteor_boss")

    inst:DoTaskInTime(warntime, dostrike)
    
    inst.warnshadow = SpawnPrefab("meteorwarning_boss")
    inst.warnshadow.entity:SetParent(inst.entity)
    inst.warnshadow.startfn(inst.warnshadow, warntime, .33, 1)

    inst:AddTag("NOCLICK")

	return inst
end

local warning_assets =
{
    Asset("ANIM", "anim/meteor_boss_shadow.zip"),
}

local function startshadow(inst, time, starttint, endtint)
    inst.components.colourtweener:StartTween({starttint,starttint,starttint,starttint}, 0)
    inst.components.colourtweener:StartTween({endtint,endtint,endtint,endtint}, time)
end

local function warning_fn()
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    local sound = inst.entity:AddSoundEmitter()

   -- sound:PlaySound("shadwell_sfx/examples/meteor_spawn")

    anim:SetBank("warning_shadow")
    anim:SetBuild("meteor_boss_shadow")
    anim:PlayAnimation("idle", true)
    anim:SetFinalOffset(-1)
    
    inst:AddComponent("colourtweener")

    inst.startfn = startshadow

    inst:AddTag("FX")
    inst.persists = false

    return inst
end

return Prefab("common/meteor_boss", fn, assets),
Prefab("common/fx/meteorwarning_boss", warning_fn, warning_assets)
