local projectile_assets =
{
    Asset("ANIM", "anim/metal_spark.zip"),
}

local projectile_prefabs =
{
	"metal_spark",
}

local FADE_FRAMES = 10
local FADE_INTENSITY = .8
local FADE_RADIUS = 1
local FADE_FALLOFF = .5

local function OnProjectileHit(inst)
    local x, y, z = inst.Transform:GetWorldPosition()
    local bomb = SpawnPrefab("metal_spark")
    bomb.Transform:SetPosition(x, y, z)
	inst:Remove()
end

local function projectile_fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    inst.entity:AddPhysics()
    inst.Physics:SetMass(1)
    inst.Physics:SetCapsule(.2, .2)
    inst.Physics:SetFriction(0)
    inst.Physics:SetDamping(0)
	
	if IsDLCEnabled(CAPY_DLC) or IsDLCEnabled(PORKLAND_DLC) then 	
	inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
	inst.Physics:ClearCollisionMask()
	inst.Physics:CollidesWith(COLLISION.GROUND)
	else
    inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
    inst.Physics:ClearCollisionMask()
    inst.Physics:CollidesWith(COLLISION.WORLD)
	end
	
    inst.AnimState:SetBank("metal_spark")
    inst.AnimState:SetBuild("metal_spark")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("NOCLICK")
	
    inst:AddComponent("locomotor")

    inst:AddComponent("complexprojectile2")
    inst.components.complexprojectile2:SetHorizontalSpeed(15)
    inst.components.complexprojectile2:SetGravity(-25)
    inst.components.complexprojectile2:SetLaunchOffset(Vector3(0, 2.5, 0))
    inst.components.complexprojectile2:SetOnHit(OnProjectileHit)	
    inst.persists = false
    return inst
end

return Prefab("spark_projectile", projectile_fn, projectile_assets, projectile_prefabs)